; flames v2.5b
; jan wassenberg 2002
;
; assume:
; > ax = 0x00??
; > bx = 0
; > si = 0x??00

org 0x100

; ds -> buf

push word 0x4000
pop ds
mov dx, 0x3c8

;	mov	dx, 0x40c8		; -> buf
;	mov	ds, dx

;	mov	dh, 0x03
	pusha

	mov	al, 0x13
	int	0x10

;___________________________________________________________________________________________
;

; palette
; > dx = 0x03c8
; > cf = 0
	salc				; al = 0
	out	dx, al
	inc	dx

pal_loop:
	pusha
	out	dx, al
	xchg	ax, bx
	out	dx, al
	xchg	ax, si
	out	dx, al
	popa

	xchg	ax, cx			; smaller encoding for cmp al

	cmp	al, 0x90		; all colors saturated yet?
	jbe	.4			; yes - skip color update

; blue (si)
; d = 00000001 for colors 0..55, d = 1 for colors 56..109
	cmp	al, 0xc6
	jbe	.1
	test	al, 0x07
	jnz	.2
.1:	inc	si
.2:

; green (bl)
; d = 1110
	cmp	al, 0xac
	jbe	.3
	test	al, 0x03
	jz	.3
	inc	bx
.3:

; red (al)
; d = 2
	cmp	al, 0xe0
	jbe	.4
	inc	cx
	inc	cx
.4:

	xchg	ax, cx
	loop	pal_loop

	popa
	mov	dl, 0xda		; dx = vga input reg port


;___________________________________________________________________________________________
;
main_loop:

; wait for retrace
; > dx = 0x3da
.1:	in	al, dx
	test	al, 0x08
	jz	.1

	pusha

; memcpy(screen, buf, 320*100)
	mov	cx, 320*100/2
	push	word 0xa820
	pop	es
rep	movsw
	push	ds
	pop	es

; fill offscreen part of buf with garbage
; > cx = 0x??00
; > si -> seed
; > di -> offscreen part of buf (0x7d00)
	mov	ch, 2
.2:	in	al, 0x40		; time
	xadd	[si], ax
	stosw
	loop	.2

; smooth buf
; avg 4 pixels, subusb 1
;   1 2
;   3
;     4
	xchg	cx, di

smooth_loop:
	mov	ax, [di]
	add	al, ah
	setc	ah
	mov	bl, [di+320]
	add	ax, bx
	mov	bl, [di+320*2+1]
	add	ax, bx
	shr	ax, 2
	jz	$+3
	dec	ax
	stosb
	loop	smooth_loop

	popa				; restore si, di
	jmp	main_loop